From 3c508ef47051556e1890702d508cfbb0ddc9c37c Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 13/16] Add DELETE for saved notifications


* Fix open-iconic icon -> font awesome

---

diff --git a/hubs/app.py b/hubs/app.py
index cc32021..ff9cb3a 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -576,6 +576,17 @@ def notifications(user):
             dict(notification=notification.__json__(), success=True)
         )
 
+@app.route('/<user>/notifications/<idx>', methods=['DELETE'])
+@app.route('/<user>/notifications/<idx>/', methods=['DELETE'])
+@login_required
+def delete_notifications(user, idx):
+    notification = session.query(hubs.models.SavedNotification).filter_by(idx=idx).first()
+    if not notification:
+        return flask.abort(400)
+    session.delete(notification)
+    session.commit()
+    return flask.jsonify(dict(status_code=200))
+
 @app.before_request
 def check_auth():
     flask.session.permanent = True
diff --git a/hubs/static/client/app/components/Dropdown.jsx b/hubs/static/client/app/components/Dropdown.jsx
index 47511f7..ae1872c 100644
--- a/hubs/static/client/app/components/Dropdown.jsx
+++ b/hubs/static/client/app/components/Dropdown.jsx
@@ -1,7 +1,7 @@
 import React from 'react';
 
 export default class Dropdown extends React.Component {
-  onClick() {
+  save() {
     const payload = {
       link: this.props.match.link,
       markup: this.props.match.markup,
@@ -11,7 +11,7 @@ export default class Dropdown extends React.Component {
 
     $.ajax({
       type: 'POST',
-      url: this.props.saveUrl,
+      url: this.props.options.saveUrl,
       data: JSON.stringify(payload),
       contentType: 'application/json',
     }).done(() => {
@@ -22,24 +22,49 @@ export default class Dropdown extends React.Component {
     });
   }
 
+  delete() {
+    $.ajax({
+      type: 'DELETE',
+      url: `${this.props.options.saveUrl}${this.props.match.idx}/`,
+    }).done((resp) => {
+      if (resp.status_code === 200) {
+        const $notification = $(`#${this.props.match.dom_id}`);
+        $notification.closest('.card-block').remove();
+      }
+    });
+  }
+
   render() {
     let saveBtn;
-    if (!this.props.match.saved && this.props.saveUrl) {
+    if (!this.props.match.saved && this.props.options.saveUrl) {
       saveBtn = (
         <button
           id={`save-${this.props.match.dom_id}`}
           className="btn btn-sm btn-primary"
-          onClick={this.onClick.bind(this)}
+          onClick={this.save.bind(this)}
           href="#"
         >
           Save
         </button>
       );
     }
+    let deleteBtn;
+    if (this.props.options.delete && this.props.options.saveUrl) {
+      deleteBtn = (
+        <button
+          id={`delete-${this.props.match.dom_id}`}
+          className="btn btn-sm btn-danger"
+          onClick={this.delete.bind(this)}
+        >
+          Remove
+        </button>
+      );
+    }
 
     return (
       <div className="pull-right">
        {saveBtn}
+        {deleteBtn}
       </div>
     );
   }
diff --git a/hubs/static/client/app/components/Feed.jsx b/hubs/static/client/app/components/Feed.jsx
index 4d6c9d2..eae102a 100644
--- a/hubs/static/client/app/components/Feed.jsx
+++ b/hubs/static/client/app/components/Feed.jsx
@@ -8,7 +8,7 @@ export default class Feed extends React.Component {
     super(props);
     this.state = {
       matches: this.props.matches,
-      messageLimit: this.props.messageLimit,
+      messageLimit: this.props.options.messageLimit,
       sse: true,
     };
     // If it wasn't instantiated with a url or an error happened, bail
@@ -33,8 +33,7 @@ export default class Feed extends React.Component {
   }
   render() {
     const feedNodes = this.state.matches.map((match, idx) => {
-      const saveUrl = this.props.saveUrl || null;
-      return <Panel match={match} saveUrl={saveUrl} key={idx} />;
+      return <Panel match={match} options={this.props.options || {}} key={idx} />;
     });
     return (
       <div>
diff --git a/hubs/static/client/app/components/Markup.jsx b/hubs/static/client/app/components/Markup.jsx
index e9b585e..437550e 100644
--- a/hubs/static/client/app/components/Markup.jsx
+++ b/hubs/static/client/app/components/Markup.jsx
@@ -20,7 +20,7 @@ export default class Markup extends React.Component {
         {timestamp}
         <Dropdown
           match={this.props.match}
-          saveUrl={this.props.saveUrl}
+          options={this.props.options}
         />
       </div>
     );
diff --git a/hubs/static/client/app/components/Panel.jsx b/hubs/static/client/app/components/Panel.jsx
index 0cd9bdf..c443155 100644
--- a/hubs/static/client/app/components/Panel.jsx
+++ b/hubs/static/client/app/components/Panel.jsx
@@ -6,9 +6,9 @@ import Markup from './Markup.jsx';
 const Panel = function (props) {
   return (
     <div className="card">
-      <div className="card-block">
+      <div className="card-block" id={props.match.dom_id}>
         <Icon match={props.match} />
-        <Markup match={props.match} saveUrl={props.saveUrl} />
+        <Markup options={props.options} match={props.match} />
       </div>
     </div>
   );
diff --git a/hubs/tests/test_api/test_notifications.py b/hubs/tests/test_api/test_notifications.py
index ea8616f..6706031 100644
--- a/hubs/tests/test_api/test_notifications.py
+++ b/hubs/tests/test_api/test_notifications.py
@@ -82,3 +82,40 @@ class TestPostNotifications(hubs.tests.APPTest):
                             for s in all_saved))
         self.assertTrue(any(str(s['link']) == self.valid_payload['link']
                             for s in all_saved))
+
+
+class TestDeleteNotifications(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('ralph')
+    notification = hubs.models.SavedNotification(
+        username='ralph',
+        markup='foo',
+        link='bar',
+        secondary_icon='baz',
+        dom_id='qux'
+    )
+
+    def test_delete_notification(self):
+        self.session.add(self.notification)
+        self.session.commit()
+        idx = self.notification.idx
+
+        self.assertIsNotNone(self.notification)
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.delete(
+                '/{}/notifications/{}/'.format(self.user.username, idx)
+            )
+
+        self.assertEqual(resp.status_code, 200)
+        notification = self.session.query(
+            hubs.models.SavedNotification).filter_by(idx=idx).first()
+
+        self.assertIsNone(notification)
+
+    def test_400_on_bad_idx(self):
+        idx = 'thisisastringnotanint'
+
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.delete(
+                '/{}/notifications/{}/'.format(self.user.username, idx)
+            )
+        self.assertEqual(resp.status_code, 400)

